﻿using System;
using System.Diagnostics;
using System.Threading;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace CodeIt_Round_5
{
    class Program
    {
        static Crossword.Crossword.MyServiceClient client = new Crossword.Crossword.MyServiceClient();

        static string[] table = new string[502], tablein = new string[502];
        static string[] words = new string[50002], ns = new string[6];
        static string curword;
        static int n, m;
        static int querynum;

        public static bool OK(int x, int y, bool vertical, out int lc)
        {
            int i;
            lc = -1;
            if (vertical == false)
            {
                if (y + curword.Length > m) return false;
                for (i = y; i < y + curword.Length; i++)
                {
                    //Console.WriteLine("Probvame da postavim {0} na {1}",curword[i-y],table[x][i]);
                    if (table[x][i] != curword[i - y] && table[x][i] != '0')
                    {
                       // Console.WriteLine("CUCUCU");
                        lc = i;
                        return false;
                    }
                   // Console.WriteLine("Produljavame");
                }
                
            }
            else
            {
                if (x + curword.Length > n) return false;
                for (i = x; i < x + curword.Length; i++)
                {
                    if (table[i][y] != curword[i - x] && table[i][y] != '0')
                    {
                        lc = i;
                        return false;
                    }
                }
            }

            return true;
        }
        public static void First_Found_Method(out int x, out int y, out bool ver, out bool success)
        {
            int i, j, lc;
            for (i = 0; i < n; i++)
            {
                for (j = 0; j < m; j++)
                {
                    if (OK(i, j, false, out lc))
                    {
                        //Console.WriteLine(client.placeWord(i, j, false));
                        x = i;
                        y = j;
                        ver = false;
                        success = true;
                        //Console.WriteLine(brd);
                        return;
                    }
                    else
                    {
                        if (lc == -1) break;
                        j = lc + 1;
                    }
                    //cout<<"na "<<i<<" "<<j<<" horizontalno ne stava "<<curword<<endl;

                    //cout<<"na "<<i<<" "<<j<<" vertikalno ne stava "<<curword<<endl;
                }
            }
            for (j = 0; j< m; j++)
            {
                for (i = 0; i < n; i++)
                {
                    if (OK(i, j, true, out lc))
                    {
                        //Console.WriteLine("Stava na {0} {1}",i,j);
                        //Console.WriteLine(client.placeWord(i, j, false));
                        x = i;
                        y = j;
                        ver = true;
                        success = true;
                        return;
                    }
                    else
                    {
                        if (lc == -1) break;
                        i = lc + 1;
                    }
                    //cout<<"na "<<i<<" "<<j<<" horizontalno ne stava "<<curword<<endl;

                    //cout<<"na "<<i<<" "<<j<<" vertikalno ne stava "<<curword<<endl;
                }
            }
            success = false;
            x = 0;
            y = 0;
            ver = false;
            return;
        }
        public static void FF_Full(out int x, out int y, out bool ver, out bool success)
        {
            int i, j,lc;
            for (i = 0; i < n; i++)
            {
                for (j = 0; j < m; j++)
                {
                    if (OK(i, j, false, out lc))
                    {
                        x = i;
                        y = j;
                        ver = false;
                        success = true;
                        return;
                    }
                    if (OK(i, j, true, out lc))
                    {
                        x = i;
                        y = j;
                        ver = true;
                        success = true;
                        return;
                    }
                }
            }
            success = false;
            x = 0;
            y = 0;
            ver = false;
            return;
        }
        

        static void Main(string[] args)
        {
            
            //TextReader reader = File.OpenText("crossword.in");
            StreamReader r = new StreamReader("crossword.in");
            int NumberOfTest = int.Parse(r.ReadLine());

            client.Init(NumberOfTest);
            //Console.WriteLine("The number of the test is {0}",NumberOfTest);
            bool scared = false,state;
            long time;
            double cool = 0.0;
            int i, j, cp, ax, ay,indn=-1;
            bool aver, success;
            Stopwatch t = new Stopwatch();
            t.Start();
            n = client.getRowCount();
            m = client.getColumnCount();
            querynum = client.getQueryCount();
            table = client.getField();
            cool = t.Elapsed.TotalMilliseconds;

            //Console.WriteLine("{0} {1}", n, m);

            for (i = 1; i <= querynum; i++)
            {
                table = client.getField();
                if (!scared)
                {
                    curword = client.nextWord();
                    if (n * m * querynum * 50 > 1000000000)
                    {
                        First_Found_Method(out ax, out ay, out aver, out success);
                    }
                    else
                    {
                        //First_Found_Method(out ax, out ay, out aver, out success);
                        FF_Full(out ax, out ay, out aver, out success);
                    }
                    if (!success) scared = true;
                    //Console.WriteLine("{0} {1}",client.placeWord(ax, ay, aver),scared);
                    client.placeWord(ax, ay, aver);
                }
                else
                {
                    ns=client.skip();
                    indn=0;
                    while (indn <ns.Length && i<=querynum)
                    {
                        table = client.getField();
                        curword = ns[indn];
                        indn++;

                        if (n * m * querynum * 50 > 1000000000)
                        {
                            First_Found_Method(out ax, out ay, out aver, out success);
                        }
                        else
                        {
                            //First_Found_Method(out ax, out ay, out aver, out success);
                            FF_Full(out ax, out ay, out aver, out success);
                        }
                        //Console.WriteLine("svurshihme");
                        if (!success)
                        {
                            //Console.WriteLine("skip\n");
                            i++;
                            ns = client.skip();
                            indn = 0;
                        }
                        else
                        {
                            i++;
                            //Console.WriteLine("CURWORD- {0}, nw- {1} ",curword,client.nextWord());
                            client.nextWord();
                            state=client.placeWord(ax, ay, aver);
                            //Console.WriteLine("Postavqme na {0} {1} sus state {2} ", ax, ay,state);
                        }
                    }
                    
                }
                
            }


            cool = t.Elapsed.TotalMilliseconds;
            //Console.WriteLine("Points won: {0} for {1}", client.EndGame(out time), cool - time);
            client.EndGame(out time);
            //Console.ReadKey();
        }
    }
}

